package principal;

import entidades.Cliente;
import java.io.IOException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

public class WSisCli extends HttpServlet {

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        try {
            // Verifica logon
            if ( logon.WLogon.verifica(request,response,"/index.jsp") == false ) return;

            // Recupera Sessão atual
            HttpSession session = request.getSession();

            // Verifica se operação mudou
            String op = request.getParameter("op");
            if (op != null) {
                int opi;
                try { opi = Integer.valueOf(op); }
                catch (Exception ex) { opi = 0; }
                session.setAttribute("WSCOper", opi);
                session.setAttribute("WSCPass", 0);
                request.setAttribute("WSCErro", 0);
                request.setAttribute("WSCErroMsg","");
            }
            
            // Recupera valores de controle
            Integer oper = (Integer)session.getAttribute("WSCOper");
            if (oper == null) oper = 0;
            Integer pass = (Integer)session.getAttribute("WSCPass");
            if (pass == null) pass = 0;
       
            // Cria referência de request para forward
            RequestDispatcher rd;
            
            // Decide o que fazer - Front Controller
            switch (oper) {
                case 0: // Menu Principal
                    session.setAttribute("WVTitle", "Menu Principal");
                    request.setAttribute("WVOper",0);
                    rd = request.getRequestDispatcher("/WView.jsp");
                    rd.forward(request,response);
                    return;
                case 1: // Cadastrar Cliente
                    session.setAttribute("WVTitle", "Cadastrar Cliente");
                    if (pass == 0) {
                        Cliente c = new Cliente();
                        session.setAttribute("cliente", c);
                        session.setAttribute("WSCPass", 1);
                        request.setAttribute("WVOper", 1); // ClienteEdit
                        rd = request.getRequestDispatcher("/WView.jsp");
                        rd.forward(request,response);
                        return;
                        }
                    else if (pass == 1) {
                        rd = request.getRequestDispatcher("/ClienteProcess");
                        rd.include(request,response);
                        // Na volta...
                        Integer erro = (Integer)request.getAttribute("WSCErro");
                        // Se deu erro, volta a imprimir tela de edição
                        if (erro != null && erro != 0) {
                            request.setAttribute("WVOper", 1); // ClienteEdit
                            rd = request.getRequestDispatcher("/WView.jsp");
                            rd.forward(request,response);
                            return;
                            }
                        // Se não houve erro... indica fim do processamento
                        session.setAttribute("WSCOper", 0);
                        session.setAttribute("WSCPass", 0);
                        request.setAttribute("WVOper", 3); // ClienteView
                        rd = request.getRequestDispatcher("/WView.jsp");
                        rd.forward(request,response);
                        return;
                        }
                    break;
                case 2: // Visualizar Cliente
                    session.setAttribute("WVTitle", "Visualizar Cliente");
                    if (pass == 0) {
                        session.setAttribute("WSCPass", 1);
                        request.setAttribute("WVOper", 2); // ClienteSearchEdit
                        rd = request.getRequestDispatcher("/WView.jsp");
                        rd.forward(request,response);
                        return;
                        }
                    else if (pass == 1) {
                        rd = request.getRequestDispatcher("/ClienteSearchProcess");
                        rd.include(request,response);
                        // Na volta...
                        Integer erro = (Integer)request.getAttribute("WSCErro");
                        // Se deu erro, volta a imprimir tela de busca
                        if (erro != null && erro != 0) {
                            request.setAttribute("WVOper", 2); // ClienteSearchEdit
                            rd = request.getRequestDispatcher("/WView.jsp");
                            rd.forward(request,response);
                            return;
                            }
                        // Se não houve erro... indica cliente encontrado, vai mostrar
                        session.setAttribute("WSCOper", 0);
                        session.setAttribute("WSCPass", 0);
                        request.setAttribute("WVOper", 3); // ClienteView
                        rd = request.getRequestDispatcher("/WView.jsp");
                        rd.forward(request,response);
                        return;
                        }
                    break;
                case 3: // Editar Cliente
                    session.setAttribute("WVTitle", "Editar Cliente");
                    if (pass == 0) {
                        session.setAttribute("WSCPass", 1);
                        request.setAttribute("WVOper", 2); // ClienteSearchEdit
                        rd = request.getRequestDispatcher("/WView.jsp");
                        rd.forward(request,response);
                        return;
                        }
                    else if (pass == 1) {
                        rd = request.getRequestDispatcher("/ClienteSearchProcess");
                        rd.include(request,response);
                        // Na volta...
                        Integer erro = (Integer)request.getAttribute("WSCErro");
                        // Se deu erro, volta a imprimir tela de busca
                        if (erro != null && erro != 0) {
                            request.setAttribute("WVOper", 2); // ClienteSearchEdit
                            rd = request.getRequestDispatcher("/WView.jsp");
                            rd.forward(request,response);
                            return;
                            }
                        // Se não houve erro... vamos pra edição
                        session.setAttribute("WSCPass", 2);
                        request.setAttribute("WVOper", 1); // ClienteEdit
                        rd = request.getRequestDispatcher("/WView.jsp");
                        rd.forward(request,response);
                        return;
                        }
                    else if (pass == 2) {
                        rd = request.getRequestDispatcher("/ClienteProcess");
                        rd.include(request,response);
                        // Na volta...
                        Integer erro = (Integer)request.getAttribute("WSCErro");
                        // Se deu erro, volta a imprimir tela de edição
                        if (erro != null && erro != 0) {
                            request.setAttribute("WVOper", 1); // ClienteEdit
                            rd = request.getRequestDispatcher("/WView.jsp");
                            rd.forward(request,response);
                            return;
                            }
                        // Se não houve erro... indica fim do processamento
                        session.setAttribute("WSCOper", 0);
                        session.setAttribute("WSCPass", 0);
                        request.setAttribute("WVOper", 3); // ClienteView
                        rd = request.getRequestDispatcher("/WView.jsp");
                        rd.forward(request,response);
                        return;
                        }
                    break;
                default: // Opção Inválida
                    rd = request.getRequestDispatcher("/WSisCli");
                    session.setAttribute("WVOper",0);
                    request.setAttribute("WSCErro",1);
                    request.setAttribute("WSCMsgErro", "Opção Inválida!");
                    rd.forward(request,response);
                    return;
            }
            
        } finally {            
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
